controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }
    
    public function actionConsulta1dao(){
   
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' SELECT  COUNT(*)AS Numero_Ciclistas FROM ciclista',
       
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['Numero_Ciclistas'],
        "titulo"=>"Consulta 1 con DAO",
        "enunciado"=>"Número de ciclistas que hay",
        "sql" =>"SELECT COUNT(*) AS Numero_Ciclistas FROM ciclista",
    ]);
        
    }
    
    public function actionConsulta1orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select ("count(*) as Numero_Ciclistas"),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['Numero_Ciclistas'],
            "titulo"=>"Consulta 1 con Active Record",
            "enunciado"=>"Número de ciclistas que hay ",
            "sql"=>"SELECT  COUNT(*) as Numero_Ciclistas FROM ciclista",
            
        ]); 
    }
    
     public function actionConsulta2dao(){
    
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' select count(*) AS ciclistas_banesto from ciclista where nomequipo = "Banesto"',
       
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['ciclistas_banesto'],
        "titulo"=>"Consulta 2 con DAO",
        "enunciado"=>"Número de ciclistas que hay del equipo Banesto ",
        "sql" =>"SELECT COUNT(*) AS ciclistas_banesto FROM ciclista where nomequipo ='Banesto' ",
    ]);
        
    }
    
    public function actionConsulta2orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select ("count(*) as ciclistas_banesto")->where  ("nomequipo = 'banesto'"),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['ciclistas_banesto'],
            "titulo"=>"Consulta 2 con Active Record",
            "enunciado"=>"Número de ciclistas que hay del equipo Banesto ",
        "sql" =>"SELECT COUNT(*) AS ciclistas_banesto FROM ciclista where nomequipo ='Banesto' ",
            
        ]); 
    }
    
     public function actionConsulta3dao(){
   
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' select avg(edad) AS Edad_Media from ciclista',
        
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['Edad_Media'],
        "titulo"=>"Consulta 3 con DAO",
        "enunciado"=>"Edad media de los ciclistas",
        "sql" =>"select avg(edad) AS Edad_Media from ciclista",
    ]);
        
    }
    
    public function actionConsulta3orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select ("avg(edad) as Edad_Media"),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['Edad_Media'],
            "titulo"=>"Consulta 3 con Active Record",
            "enunciado"=>"Edad media de los ciclistas ",
            "sql"=>"select avg(edad) AS Edad_Media from ciclista",
            
        ]); 
    }
    
     public function actionConsulta4dao(){
    
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' SELECT  AVG(edad)AS Edad_Media_Banesto FROM ciclista where nomequipo = "Banesto"',
        
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['Edad_Media_Banesto'],
        "titulo"=>"Consulta 4 con DAO",
        "enunciado"=>"La edad media de los del equipo Banesto",
        "sql" =>"SELECT  AVG(edad)AS Edad_Media_Banesto FROM ciclista where nomequipo = 'Banesto'",
    ]);
        
    }
    
    public function actionConsulta4orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select ("avg(edad) as Edad_Media_Banesto")-> where ("nomequipo = 'banesto'"),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['Edad_Media_Banesto'],
            "titulo"=>"Consulta 4 con Active Record",
            "enunciado"=>"La edad media de los del equipo Banesto ",
            "sql"=>"SELECT  AVG(edad)AS Edad_Media_Banesto FROM ciclista where nomequipo = 'Banesto'",
            
        ]); 
    }
    
     public function actionConsulta5dao(){
    
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' SELECT  AVG(edad)AS Edad_Media_por_equipo FROM ciclista GROUP BY  nomequipo',
        
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['Edad_Media_por_equipo'],
        "titulo"=>"Consulta 5 con DAO",
        "enunciado"=>"La edad media de los ciclistas por cada equipo",
        "sql" =>"SELECT  AVG(edad)AS Edad_Media_por_equipo FROM ciclista GROUP BY  nomequipo",
    ]);
        
    }
    
    public function actionConsulta5orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select ("avg(edad) as Edad_Media_Por_Equipo")->groupBy('nomequipo'),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['Edad_Media_Por_Equipo'],
            "titulo"=>"Consulta 5 con Active Record",
            "enunciado"=>"La edad media de los ciclistas por cada equipo ",
            "sql"=>"SELECT  avg(edad) as Edad_Media_Por_Equipo FROM ciclista",
            
        ]); 
    }
    
     public function actionConsulta6dao(){
    
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' select count(dorsal) AS Total_Ciclistas_equipo from ciclista group by nomequipo',
        
        'pagination'=>[
            'pageSize' => 5,
        ]  
    ]) ;
    
    return $this->render ("resultado", [
        "resultados" =>$dataProvider,
        "campos"=>['Total_Ciclistas_equipo'],
        "titulo"=>"Consulta 6 con DAO",
        "enunciado"=>"El número de ciclistas por equipo",
        "sql" =>"Select count(dorsal) AS Total_Ciclistas_equipo from ciclista group by nomequipo",
    ]);
        
    }
    
    public function actionConsulta6orm(){
        $dataProvider = new ActiveDataProvider([
        'query' => \app\models\Ciclista::find()->select ("count(dorsal) as Total_Ciclistas_equipo")->groupBy('nomequipo'),
       'pagination' =>[
           'pageSize' =>5,
       ]        
        ]);
        
        return $this->render("resultado", [
        "resultados"=>$dataProvider,
            "campos"=>['Total_Ciclistas_equipo'],
            "titulo"=>"Consulta 6 con Active Record",
            "enunciado"=>"El número de ciclistas por equipo",
            "sql"=>"Select count(dorsal) AS Total_Ciclistas_equipo from ciclista group by nomequipo",
            
        ]); 
    }
    
     public function actionConsulta7dao(){
   
    
    $dataProvider = new SqlDataProvider([
        'sql'=>' SELECT COUNT(nompuerto) AS numero_total_puertos FROM puerto',
        
        'pagination'=>[

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;

/* @var $this yii\web\View */

$this->title = 'Ejercicio 2 Consultas';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de selección 2</h1>

       
        </div>

    <div class="body-content">

        <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 1</h2>

                <p>Número de ciclistas que hay </p>

                <p>

<?= Html:: a('DAO', ['site/consulta1dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta1orm'], ['class' => 'btn btn-default']) ?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 2</h2>

                <p>Número de ciclistas que hay del equipo Banesto
</p>
 <p>
                   
<?= Html:: a('DAO', ['site/consulta2dao'], ['class' => 'btn btn-primary']) ?>
     
<?= Html::a('Active Record', ['site/consulta2orm'], ['class' => 'btn btn-default']) ?>
                   
                </p>
            </div>
                    </div>
                </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 3</h2>

                <p>Edad media de los ciclistas
</p>

<?= Html:: a('DAO', ['site/consulta3dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta3orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            </div>
        <div class="row">
            <div class="col-lg-4">
                 <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 4</h2>

                <p>La edad media de los del equipo Banesto</p>

<?= Html:: a('DAO', ['site/consulta4dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta4orm'], ['class' => 'btn btn-default']) ?>
            </div>
                      </div>
                 </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 5</h2>
                
                 <p>La edad media de los ciclistas por cada equipo</p>

<?= Html:: a('DAO', ['site/consulta5dao'], ['class' => 'btn btn-primary']) ?>
                 
<?= Html::a('Active Record', ['site/consulta5orm'], ['class' => 'btn btn-default']) ?>
                
            </div>
                    </div>
                </div>
            <div class="col-lg-4">
                 <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 6</h2>

                <p>El número de ciclistas por equipo</p>

<?= Html:: a('DAO', ['site/consulta6dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta6orm'], ['class' => 'btn btn-default']) ?>
            </div>
                      </div>
                 </div>
            </div>
        <div class="row">
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 7</h2>

                <p>El número total de puertos </p>

<?= Html:: a('DAO', ['site/consulta7dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta7orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 8</h2>

                <p>El número total de puertos mayores de 1500</p>

<?= Html:: a('DAO', ['site/consulta8dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta8orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            <div class="col-lg-4">
                 <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 9</h2>

                <p>Listar el nombre de los equipos que tengan más de 4 ciclistas </p>

<?= Html:: a('DAO', ['site/consulta9dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta9orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
            </div>
             </div>
        <div class="row">
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 10</h2>

                <p>Listar el nombre de los equipos que tengan más de 4 ciclistas cuya edad esté entre 28 y 32</p>

<?= Html:: a('DAO', ['site/consulta10dao'], ['class' => 'btn btn-primary']) ?>
                
<?= Html::a('Active Record', ['site/consulta10orm'], ['class' => 'btn btn-default']) ?>
            </div>
                     </div>
                 </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 11</h2>

                <p>Indícame el número de etapas que ha ganado cada uno de los ciclistas</p>

                <?= Html:: a('DAO', ['site/consulta11dao'], ['class' => 'btn btn-primary']) ?>
                <?= Html::a('Active Record', ['site/consulta11orm'], ['class' => 'btn btn-default']) ?>
            </div>
                       </div>
                   </div>
            <div class="col-lg-4">
                <div class ="thumbnail">
                    <div class ="caption">
                <h2>Consulta 12</h2>

                <p>Indícame el dorsal de los ciclistas que hayan ganado más de una etapa</p>

                <?= Html:: a('DAO', ['site/consulta12dao'], ['class' => 'btn btn-primary']) ?>
                <?= Html::a('Active Record', ['site/consulta12orm'], ['class' => 'btn btn-default']) ?>
            </div>
                       </div>
                   </div>
            
        </div>

    </div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"col-lg-offset-1 col-lg-3\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="col-lg-offset-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php

use yii\grid\GridView;

?>

<div class =""jumbotron">
     <h2><?=$titulo?></h2>
    
    
    <p class ="lead"><?= $enunciado ?></p>
    <div class="well">
        <?= $sql ?>
    </div>
           
    </div>

<?=GridView::widget([
    'dataProvider' => $resultados,
    'columns'=>$campos
    
    
]); ?>